double dsqr(double x)
{
	return x*x;
}
int isqr(int x)
{
	return x*x;
}
/*	Auxiliary routines for TAYLOR.EXE*/
void simp1(double **a, int mm, int ll[], int nll, int iabf, int *kp,double *bmax)
{
	int k;
	double test;

	*kp=ll[1];
	*bmax=a[mm+1][*kp+1];
	for (k=2;k<=nll;k++) {
		if (iabf == 0)
			test=a[mm+1][ll[k]+1]-(*bmax);
		else
			test=fabs(a[mm+1][ll[k]+1])-fabs(*bmax);
		if (test > 0.0) {
			*bmax=a[mm+1][ll[k]+1];
			*kp=ll[k];
		}
	}
}
void simp2(double **a, int n, int l2[], int nl2, int *ip, int kp, double *q1)
{
	int k,ii,i;
	double qp,q0,q;

	*ip=0;
	for (i=1;i<=nl2;i++) {
		if (a[l2[i]+1][kp+1] < -EPS) {
			*q1 = -a[l2[i]+1][1]/a[l2[i]+1][kp+1];
			*ip=l2[i];
			for (i=i+1;i<=nl2;i++) {
				ii=l2[i];
				if (a[ii+1][kp+1] < -EPS) {
					q = -a[ii+1][1]/a[ii+1][kp+1];
					if (q < *q1) {
						*ip=ii;
						*q1=q;
					} else if (q == *q1) {
						for (k=1;k<=n;k++) {
							qp = -a[*ip+1][k+1]/a[*ip+1][kp+1];
							q0 = -a[ii+1][k+1]/a[ii+1][kp+1];
							if (q0 != qp) break;
						}
						if (q0 < qp) *ip=ii;
					}
				}
			}
		}
	}
}
void simp3(double **a, int i1, int k1, int ip, int kp)
{
	int kk,ii;
	double piv;

	piv=1.0/a[ip+1][kp+1];
	for (ii=1;ii<=i1+1;ii++)
		if (ii-1 != ip) {
			a[ii][kp+1] *= piv;
			for (kk=1;kk<=k1+1;kk++)
				if (kk-1 != kp)
					a[ii][kk] -= a[ip+1][kk]*a[ii][kp+1];
		}
	for (kk=1;kk<=k1+1;kk++)
		if (kk-1 != kp) a[ip+1][kk] *= -piv;
	a[ip+1][kp+1]=piv;
}
void simplx(double **a, int m, int n, int m1, int m2, int m3, int icase,
	int izrov[], int iposv[])
{
	void simp1(double **a, int mm, int ll[], int nll, int iabf, int *kp,
		double *bmax);
	void simp2(double **a, int n, int l2[], int nl2, int *ip, int kp, double *q1);
	void simp3(double **a, int i1, int k1, int ip, int kp);
	int i,ip,ir,is,k,kh,kp,m12,nl1,nl2;
	int *l1,*l2,*l3;
	double q1,bmax;

	icase *= 1;
	if (m != (m1+m2+m3)) nrerror("Bad input constraint counts in simplx");
	l1=ivector(1,n+1);
	l2=ivector(1,m);
	l3=ivector(1,m);
	nl1=n;
	for (k=1;k<=n;k++) l1[k]=izrov[k]=k;
	nl2=m;
	for (i=1;i<=m;i++) {
		if (a[i+1][1] < 0.0) nrerror("Bad input tableau in simplx");
		l2[i]=i;
		iposv[i]=n+i;
	}
	for (i=1;i<=m2;i++) l3[i]=1;
	ir=0;
	if (m2+m3) {
		ir=1;
		for (k=1;k<=(n+1);k++) {
			q1=0.0;
			for (i=m1+1;i<=m;i++) q1 += a[i+1][k];
			a[m+2][k] = -q1;
		}
		do {
			simp1(a,m+1,l1,nl1,0,&kp,&bmax);
			if (bmax <= EPS && a[m+2][1] < -EPS) {
				icase = -1;
				FREEALL return;
			} else if (bmax <= EPS && a[m+2][1] <= EPS) {
				m12=m1+m2+1;
				if (m12 <= m) {
					for (ip=m12;ip<=m;ip++) {
						if (iposv[ip] == (ip+n)) {
							simp1(a,ip,l1,
								nl1,1,&kp,&bmax);
							if (bmax > 0.0)
								goto one;
						}
					}
				}
				ir=0;
				--m12;
				if (m1+1 <= m12)
					for (i=m1+1;i<=m12;i++)
						if (l3[i-m1] == 1)
							for (k=1;k<=n+1;k++)
								a[i+1][k] = -a[i+1][k];
				break;
			}
			simp2(a,n,l2,nl2,&ip,kp,&q1);
			if (ip == 0) {
				icase = -1;
				FREEALL return;
			}
	one:	simp3(a,m+1,n,ip,kp);
			if (iposv[ip] >= (n+m1+m2+1)) {
				for (k=1;k<=nl1;k++)
					if (l1[k] == kp) break;
				--nl1;
				for (is=k;is<=nl1;is++) l1[is]=l1[is+1];
				++a[m+2][kp+1];
				for (i=1;i<=m+2;i++) a[i][kp+1] = -a[i][kp+1];
			} else {
				if (iposv[ip] >= (n+m1+1)) {
					kh=iposv[ip]-m1-n;
					if (l3[kh]) {
						l3[kh]=0;
						++a[m+2][kp+1];
						for (i=1;i<=m+2;i++)
							a[i][kp+1] = -a[i][kp+1];
					}
				}
			}
			is=izrov[kp];
			izrov[kp]=iposv[ip];
			iposv[ip]=is;
		} while (ir);
	}
	for (;;) {
		simp1(a,0,l1,nl1,0,&kp,&bmax);
		if (bmax <= 0.0) {
			icase=0;
			FREEALL return;
		}
		simp2(a,n,l2,nl2,&ip,kp,&q1);
		if (ip == 0) {
			icase=1;
			FREEALL return;
		}
		simp3(a,m,n,ip,kp);
		is=izrov[kp];
		izrov[kp]=iposv[ip];
		iposv[ip]=is;
	}
}
void nrerror(char error_text[])
/* Standard error handler */
{
	fprintf(stderr,"Run-time error...\n");
	fprintf(stderr,"%s\n",error_text);
	fprintf(stderr,"...now exiting to system...\n");
	getc(stdin);
	exit(1);
}
double **matrix(int nrl, int nrh, int ncl, int nch)
/* allocate a double matrix with subscript range m[nrl..nrh][ncl..nch] */
{
	int i, nrow=nrh-nrl+1,ncol=nch-ncl+1;
	double **m;

	/* allocate pointers to rows */
	m=(double **) malloc((size_t)((nrow+NR_END)*sizeof(double*)));
	if (!m) nrerror("allocation failure 1 in matrix()");
	m += NR_END;
	m -= nrl;

	/* allocate rows and set pointers to them */
	m[nrl]=(double *) malloc((size_t)((nrow*ncol+NR_END)*sizeof(double)));
	if (!m[nrl]) nrerror("allocation failure 2 in matrix()");
	m[nrl] += NR_END;
	m[nrl] -= ncl;

	for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;

	/* return pointer to array of pointers to rows */
	return m;
}
int **imatrix(int nrl, int nrh, int ncl, int nch)
/* allocate a int matrix with subscript range m[nrl..nrh][ncl..nch] */
{
	int i, nrow=nrh-nrl+1,ncol=nch-ncl+1;
	int **m;

	/* allocate pointers to rows */
	m=(int **) malloc((size_t)((nrow+NR_END)*sizeof(int*)));
	if (!m) nrerror("allocation failure 1 in matrix()");
	m += NR_END;
	m -= nrl;


	/* allocate rows and set pointers to them */
	m[nrl]=(int *) malloc((size_t)((nrow*ncol+NR_END)*sizeof(int)));
	if (!m[nrl]) nrerror("allocation failure 2 in matrix()");
	m[nrl] += NR_END;
	m[nrl] -= ncl;

	for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;

	/* return pointer to array of pointers to rows */
	return m;
}
void free_imatrix(int **m, int nrl, int nrh, int ncl, int nch)
/* free an int matrix allocated by imatrix() */
{
	free((FREE_ARG) (m[nrl]+ncl-NR_END));
	free((FREE_ARG) (m+nrl-NR_END));
	nrh *=nch; /* To avoid warnings!!!*/
}
void free_ivector(int *v, int nl, int nh)
/* free an int vector allocated with ivector() */
{
	free((FREE_ARG) (v+nl+nh-nh-NR_END));
}
int *ivector(int nl, int nh)
/* allocate an int vector with subscript range v[nl..nh] */
{
	int *v;

	v=(int *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(int)));
	if (!v) nrerror("allocation failure in ivector()");
	return v-nl+NR_END;
}
double *vector(int nl, int nh)
/* allocate a double vector with subscript range v[nl..nh] */
{
	double *v;

	v=(double *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(double)));
	if (!v) nrerror("allocation failure in vector()");
	return v-nl+NR_END;
}
double ***f3tensor(int nrl, int nrh, int ncl, int nch, int ndl, int ndh)
/* allocate a double 3tensor with range t[nrl..nrh][ncl..nch][ndl..ndh] */
{
	int i,j,nrow=nrh-nrl+1,ncol=nch-ncl+1,ndep=ndh-ndl+1;
	double ***t;

	/* allocate pointers to pointers to rows */
	t=(double ***) malloc((size_t)((nrow+NR_END)*sizeof(double**)));
	if (!t) nrerror("allocation failure 1 in f3tensor()");
	t += NR_END;
	t -= nrl;

	/* allocate pointers to rows and set pointers to them */
	t[nrl]=(double **) malloc((size_t)((nrow*ncol+NR_END)*sizeof(double*)));
	if (!t[nrl]) nrerror("allocation failure 2 in f3tensor()");
	t[nrl] += NR_END;
	t[nrl] -= ncl;

	/* allocate rows and set pointers to them */
	t[nrl][ncl]=(double *) malloc((size_t)((nrow*ncol*ndep+NR_END)*sizeof(double)));
	if (!t[nrl][ncl]) nrerror("allocation failure 3 in f3tensor()");
	t[nrl][ncl] += NR_END;
	t[nrl][ncl] -= ndl;

	for(j=ncl+1;j<=nch;j++) t[nrl][j]=t[nrl][j-1]+ndep;
	for(i=nrl+1;i<=nrh;i++) {
		t[i]=t[i-1]+ncol;
		t[i][ncl]=t[i-1][ncl]+ncol*ndep;
		for(j=ncl+1;j<=nch;j++) t[i][j]=t[i][j-1]+ndep;
	}

	/* return pointer to array of pointers to rows */
	return t;
}
void free_vector(double *v, int nl, int nh)
/* free a double vector allocated with vector() */
{
	free((FREE_ARG) (v+nl+nh-nh-NR_END));
}
void free_matrix(double **m, int nrl, int nrh, int ncl, int nch)
/* free a double matrix allocated by matrix() */
{
	free((FREE_ARG) (m[nrl]+ncl+nrh-nrh-NR_END));
	free((FREE_ARG) (m+nrl+nch-nch-NR_END));
}
void free_f3tensor(double ***t, int nrl, int nrh, int ncl, int nch,
	int ndl, int ndh)
/* free a double f3tensor allocated by f3tensor() */
{
	free((FREE_ARG) (t[nrl][ncl]+ndl+ndh-ndh-NR_END));
	free((FREE_ARG) (t[nrl]+ncl+nch-nch-NR_END));
	free((FREE_ARG) (t+nrl+nrh-nrh-NR_END));
}
void quick_sort(int vector[], int left, int right)
{
	int l, r, midle,temp;

	l = left;
	r = right;
	midle =  vector[(l + r) / 2];
	do
	{
		while(vector[l] < midle)
			l++;
		while(vector[r] > midle)
			r--;
		if(l <= r)
		{
			temp = vector[l];
			vector[l] = vector[r];
			vector[r] = temp;
			l++, r--;
		}
	}
	while(l <= r);
	if(left < r)
		quick_sort(vector, left, r);
	if( l < right)
		quick_sort(vector, l, right);
}
void lubksb(double **a, int n, int *indx, double *b)
{
	int i,ii=0,ip,j;
	double sum;

	for (i=1;i<=n;i++) {
		ip=indx[i];
		sum=b[ip];
		b[ip]=b[i];
		if (ii)
			for (j=ii;j<=i-1;j++) sum -= a[i][j]*b[j];
		else if (sum) ii=i;
		b[i]=sum;
	}
	for (i=n;i>=1;i--) {
		sum=b[i];
		for (j=i+1;j<=n;j++) sum -= a[i][j]*b[j];
		b[i]=sum/a[i][i];
	}
}
void ludcmp(double **a, int n, int *indx, double *d)
{
	int i,imax,j,k;
	double big,dum,sum,temp;
	double *vv;

	vv=vector(1,n);
	*d=1.0;
	for (i=1;i<=n;i++) {
		big=0.0;
		for (j=1;j<=n;j++)
			if ((temp=fabs(a[i][j])) > big) big=temp;
		if (big == 0.0) nrerror("Singular matrix in routine ludcmp");
		vv[i]=1.0/big;
	}
	for (j=1;j<=n;j++) {
		for (i=1;i<j;i++) {
			sum=a[i][j];
			for (k=1;k<i;k++) sum -= a[i][k]*a[k][j];
			a[i][j]=sum;
		}
		big=0.0;
		for (i=j;i<=n;i++) {
			sum=a[i][j];
			for (k=1;k<j;k++)
				sum -= a[i][k]*a[k][j];
			a[i][j]=sum;
			if ( (dum=vv[i]*fabs(sum)) >= big) {
				big=dum;
				imax=i;
			}
		}
		if (j != imax) {
			for (k=1;k<=n;k++) {
				dum=a[imax][k];
				a[imax][k]=a[j][k];
				a[j][k]=dum;
			}
			*d = -(*d);
			vv[imax]=vv[j];
		}
		indx[j]=imax;
		if (a[j][j] == 0.0) a[j][j]=TINY;
		if (j != n) {
			dum=1.0/(a[j][j]);
			for (i=j+1;i<=n;i++) a[i][j] *= dum;
		}
	}
	free_vector(vv,1,n);
}
void check_angle(int *ins_dir, double ang, int *ins_vec, double **q,int mark)
{
	int sel;
	double *pole,length,dir1,dir2,dir3;
	pole=vector(1,3);

	for(i=1;i<=3;i++)
	{
		*(pole+i) = 0;
		for(j=1;j<=3;j++)
			*(pole+i) += *(*(q+j)+i)* *(ins_vec+j);
	}
	length = sqrt(isqr(*(ins_dir+1)) + isqr(*(ins_dir+2)) + isqr(*(ins_dir+3)))*
				sqrt(dsqr(*(pole+1)) + dsqr(*(pole+2)) + dsqr(*(pole+3)));
	sel=0;
	while(sel<24)
	{
		sel++;
		if(sel==1)
		{
			dir1 =  *(ins_dir+1);
			dir2 =  *(ins_dir+2);
			dir3 =  *(ins_dir+3);
		}
		else if(sel==2)
		{
			dir1 = -*(ins_dir+1);
			dir2 =  *(ins_dir+2);
			dir3 =  *(ins_dir+3);
		}
		else if(sel==3)
		{
			dir1 =  *(ins_dir+1);
			dir2 = -*(ins_dir+2);
			dir3 =  *(ins_dir+3);
		}
		else if(sel==4)
		{
			dir1 =  *(ins_dir+1);
			dir2 =  *(ins_dir+2);
			dir3 = -*(ins_dir+3);
		}
		else if(sel==5)
		{
			dir1 =  *(ins_dir+1);
			dir2 =  *(ins_dir+3);
			dir3 =  *(ins_dir+2);
		}
		else if(sel==6)
		{
			dir1 = -*(ins_dir+1);
			dir2 =  *(ins_dir+3);
			dir3 =  *(ins_dir+2);
		}
		else if(sel==7)
		{
			dir1 =  *(ins_dir+1);
			dir2 = -*(ins_dir+3);
			dir3 =  *(ins_dir+2);
		}
		else if(sel==8)
		{
			dir1 =  *(ins_dir+1);
			dir2 =  *(ins_dir+3);
			dir3 = -*(ins_dir+2);
		}
		else if(sel==9)
		{
			dir1 =  *(ins_dir+2);
			dir2 =  *(ins_dir+1);
			dir3 =  *(ins_dir+3);
		}
		else if(sel==10)
		{
			dir1 = -*(ins_dir+2);
			dir2 =  *(ins_dir+1);
			dir3 =  *(ins_dir+3);
		}
		else if(sel==11)
		{
			dir1 =  *(ins_dir+2);
			dir2 = -*(ins_dir+1);
			dir3 =  *(ins_dir+3);
		}
		else if(sel==12)
		{
			dir1 =  *(ins_dir+2);
			dir2 =  *(ins_dir+1);
			dir3 = -*(ins_dir+3);
		}
		else if(sel==13)
		{
			dir1 =  *(ins_dir+2);
			dir2 =  *(ins_dir+3);
			dir3 =  *(ins_dir+1);
		}
		else if(sel==14)
		{
			dir1 = -*(ins_dir+2);
			dir2 =  *(ins_dir+3);
			dir3 =  *(ins_dir+1);
		}
		else if(sel==15)
		{
			dir1 =  *(ins_dir+2);
			dir2 = -*(ins_dir+3);
			dir3 =  *(ins_dir+1);
		}
		else if(sel==16)
		{
			dir1 =  *(ins_dir+2);
			dir2 =  *(ins_dir+3);
			dir3 = -*(ins_dir+1);
		}
		else if(sel==17)
		{
			dir1 =  *(ins_dir+3);
			dir2 =  *(ins_dir+1);
			dir3 =  *(ins_dir+2);
		}
		else if(sel==18)
		{
			dir1 = -*(ins_dir+3);
			dir2 =  *(ins_dir+1);
			dir3 =  *(ins_dir+2);
		}
		else if(sel==19)
		{
			dir1 =  *(ins_dir+3);
			dir2 = -*(ins_dir+1);
			dir3 =  *(ins_dir+2);
		}
		else if(sel==20)
		{
			dir1 =  *(ins_dir+3);
			dir2 =  *(ins_dir+1);
			dir3 = -*(ins_dir+2);
		}
		else if(sel==21)
		{
			dir1 =  *(ins_dir+3);
			dir2 =  *(ins_dir+2);
			dir3 =  *(ins_dir+1);
		}
		else if(sel==22)
		{
			dir1 = -*(ins_dir+3);
			dir2 =  *(ins_dir+2);
			dir3 =  *(ins_dir+1);
		}
		else if(sel==23)
		{
			dir1 =  *(ins_dir+3);
			dir2 = -*(ins_dir+2);
			dir3 =  *(ins_dir+1);
		}
		else
		{
			dir1 =  *(ins_dir+3);
			dir2 =  *(ins_dir+2);
			dir3 = -*(ins_dir+1);
		}
		if(mark==0)
		if(fabs(*(pole+1)*dir1 + *(pole+2)*dir2 + *(pole+3)*dir3)/length >= ang)
			stop=1;

		if(mark==1)
		if(fabs(*(pole+1)*dir1+ *(pole+2)*dir2+ *(pole+3)*dir3)/length >= ang)
			init_stop=1;
		if(mark==0 && stop>0)
			break;
		if(mark==1 && init_stop>0)
			break;
	}
	free_vector(pole,1,3);
}/* void check_angle*/

